<?php

namespace Drupal\nodejs_translate\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\node\Entity\Node;
use Drupal\nodejs_translate\NodejsTranslator;
use Symfony\Component\HttpFoundation\Request;
use GuzzleHttp\Stream\Stream;
use Symfony\Component\DependencyInjection\ContainerInterface;

class NodeTranslateController extends ControllerBase {

  /**
   * Translator for text service.
   *
   * @var \Drupal\nodejs_translate\NodejsTranslator
   */
  protected $translator;

  /**
   * BookTranslateController constructor.
   *
   * @param \Drupal\nodejs_translate\NodejsTranslator $translator
   *   The text translator.
   */
  public function __construct(NodejsTranslator $translator) {
    $this->translator = $translator;
  }

  /**
   * {@inheritdoc}
   *
   * @param \Symfony\Component\DependencyInjection\ContainerInterface $container
   *   The Drupal service container.
   *
   * @return static
   */
  public static function create(ContainerInterface $container) {
    return new static(
      $container->get('nodejs_translate.nodejs_translator')
    );
  }

  /**
   * @param Node $node
   * @param Request $request
   * @return string[]
   * @throws \Drupal\Core\Entity\EntityStorageException
   *
   * Translate single node.
   */
  public function singleTranslate(Node $node, Request $request) {
    $this->translator->translateEntity($node);
    // @todo Add here something meaningful.
    return [
      '#type' => 'markup',
      '#markup' => $this->t('Translated:') . ' ' . $node->toLink()->toString(),
    ];
  }
}
